import { jsxs as N, jsx as I } from "react/jsx-runtime";
import { useCallback as v, useMemo as O, useState as k, useRef as E, useEffect as L } from "react";
import { c as j, a as q, f as B, m as F, b as H, i as R, e as U } from "../tools/tools.js";
import { A as W } from "./alert-link.js";
import { A as z } from "./alert-heading.js";
import { B as D } from "../button/button.js";
const { logWarning: K } = U(), M = {
  clickToClose: !0
}, _ = (g) => {
  const { fade: i, visible: e, dismissible: a, clickToClose: r, onClose: s } = g, [c, t] = k(!i && typeof e == "boolean" ? e : !0), [l, o] = k(!1), d = E(null), b = E(!1);
  b.current || (b.current = !0, typeof e == "boolean" && a && r && typeof s != "function" && K({
    param: "visible",
    component: "Alert",
    message: "When using 'visible' and 'dismissible' to control the Alert component, please manually handle the close event of the dismissible close button to avoid inconsistencies with the 'visible' state."
  }));
  const f = v(() => {
    i ? o(!1) : t(!1);
  }, [i]), n = v(() => {
    typeof e == "boolean" && a ? s == null || s() : r ? (f(), s == null || s()) : s == null || s(f);
  }, [r, a, f, s, e]);
  return L(() => {
    typeof e == "boolean" ? i ? e ? t(!0) : o(!1) : t(e) : i && o(!0);
  }, [i, e]), L(() => {
    if (!i)
      return;
    const m = d.current;
    if (m) {
      const p = () => {
        typeof e == "boolean" ? e || t(!1) : !l && c && t(!1);
      };
      return m.addEventListener("transitionend", p), typeof e == "boolean" && e && requestAnimationFrame(() => {
        o(!0);
      }), () => m.removeEventListener("transitionend", p);
    }
  }, [i, e, c, l]), { isVisible: c, isShowing: l, alertElement: d, handleClose: n };
}, A = function(i) {
  const {
    as: e = "div",
    dropOldClass: a,
    variables: r,
    className: s,
    style: c,
    variant: t,
    dismissible: l,
    fade: o,
    onClose: d,
    clickToClose: b = M.clickToClose,
    closeButton: f,
    closeButtonProps: n,
    visible: m,
    ...p
  } = i, { isVisible: S, isShowing: C, alertElement: T, handleClose: y } = _({
    fade: o,
    visible: m,
    dismissible: l,
    clickToClose: b,
    onClose: d
  }), V = v(
    (u) => {
      var h;
      y(), (h = n == null ? void 0 : n.onClick) == null || h.call(n, u);
    },
    [n, y]
  ), w = O(() => {
    const u = j(
      !a && "alert",
      t && `alert-${t}`,
      l && "alert-dismissible",
      o && "fade",
      C && "show",
      s
    ), h = q({ ...r, ...c }, !0, ($, x) => H(x));
    return B(
      {
        className: u,
        style: h
      },
      R
    );
  }, [s, l, a, o, C, c, r, t]);
  return S && /* @__PURE__ */ N(e, { ...p, ...w, ref: T, children: [
    i.children,
    l && (f ? f({ close: y }) : /* @__PURE__ */ I(
      D,
      {
        btnClose: !0,
        ...F(n, {
          onClick: (u) => V(u)
        })
      }
    ))
  ] });
};
A.Link = W;
A.Heading = z;
A.displayName = "BRL.Alert";
export {
  A
};
//# sourceMappingURL=alert.js.map
