import { jsxs as x, Fragment as A, jsx as t } from "react/jsx-runtime";
import { useState as w, useRef as ne, useMemo as se, useCallback as T, useEffect as N } from "react";
import { n as re, c as ae, g as de, a as le, f as ie, m as ce, o as pe, b as ue, i as fe } from "../tools/tools.js";
import { D as g } from "./dropdown-toggle.js";
import { D as O } from "./dropdown-item.js";
import { D as H } from "./dropdown-item-text.js";
import { D as K } from "./dropdown-menu.js";
import { D as q } from "./dropdown-divider.js";
import { D as z } from "./dropdown-header.js";
import { u as me, o as ge, s as he, f as be, a as we } from "../vendor.js";
const d = function(G) {
  const {
    as: U = "div",
    dropOldClass: k,
    variables: E,
    className: R,
    style: I,
    options: _,
    toggle: D,
    toggleProps: s,
    buttonProps: S,
    split: i,
    btnGroup: L,
    center: y,
    dropup: v,
    dropupCenter: C,
    dropend: M,
    dropstart: r,
    strategy: J = "absolute",
    menuProps: a,
    children: Q,
    customMenu: c,
    offset: W,
    autoClose: h = !0,
    visible: b,
    ...X
  } = G, Y = (_ ?? []).map((e, n) => ({
    ...e,
    id: e.id ?? n
  })), [Z] = w(Y), [o, p] = w(b ?? !1), u = ne(re()), [F, V] = w(), [B, j] = w(!1), { refs: f, floatingStyles: $ } = me({
    open: o,
    onOpenChange: p,
    middleware: [
      ge(() => W ?? 0, [o]),
      he((e) => e, [o]),
      be((e) => e, [o]),
      we((e) => e, [o])
    ],
    placement: pe(
      {
        "bottom-start": F === "start",
        "bottom-end": F === "end",
        "left-start": r,
        "right-start": M,
        top: C,
        "top-start": v,
        bottom: y
      },
      "bottom-start"
    ),
    strategy: J
  }), P = se(() => {
    const e = ae(
      !k && de({
        "dropup-center": C,
        "dropdown-center": y,
        "btn-group": i || L,
        dropdown: !0
      }),
      v && "dropup",
      M && "dropend",
      r && "dropstart",
      R
    ), n = le({ ...E, ...I }, !0, (l, oe) => ue(oe));
    return ie(
      {
        className: e,
        style: n
      },
      fe
    );
  }, [L, y, R, k, M, r, v, C, i, I, E]), m = T(
    (e) => {
      var n;
      p(typeof e == "boolean" ? e : e ? !o : !1), (n = s == null ? void 0 : s.onClick) == null || n.call(
        s,
        e
      );
    },
    [o, s == null ? void 0 : s.onClick]
  ), ee = T(() => {
    c && j(!0);
  }, [c]), te = T(() => {
    c && j(!1);
  }, [c]);
  return N(() => {
    typeof b == "boolean" && p(b);
  }, [b]), N(() => {
    if (!h || B)
      return;
    const e = (n) => {
      const l = n.target;
      if (l.className.includes("dropdown")) {
        if (h === "outside")
          return;
        l.dataset.toggleId !== u.current && m();
      } else h !== "inside" && m();
    };
    return document.body.addEventListener("click", e), () => document.body.removeEventListener("click", e);
  }, [h, B, m]), N(() => {
    var n;
    if (!a || !((n = a.className) != null && n.includes("dropdown-menu-")))
      return;
    const e = f.floating.current;
    if (e) {
      const l = getComputedStyle(e).getPropertyValue("--bs-position");
      V(l || !1);
    }
  }, [a, f.floating]), /* @__PURE__ */ x(U, { ...X, ...P, children: [
    i ? /* @__PURE__ */ x(A, { children: [
      !(i && r) && /* @__PURE__ */ t(g, { dropOldClass: !0, ...S, children: D }),
      /* @__PURE__ */ t(
        g,
        {
          className: "dropdown-toggle-split",
          "aria-expanded": o ? "true" : "false",
          show: o,
          ...s,
          onClick: m,
          "data-toggle-id": u.current,
          onRef: f.setReference,
          children: /* @__PURE__ */ t("span", { className: "visually-hidden", children: "Toggle Dropdown" })
        }
      )
    ] }) : /* @__PURE__ */ x(
      g,
      {
        "aria-expanded": o ? "true" : "false",
        show: o,
        ...s,
        onClick: m,
        "data-toggle-id": u.current,
        onRef: f.setReference,
        children: [
          r && /* @__PURE__ */ t("span", { className: "dropdown-nbsp", "data-toggle-id": u.current, children: " " }),
          D,
          !r && /* @__PURE__ */ t("span", { className: "dropdown-nbsp", "data-toggle-id": u.current, children: " " })
        ]
      }
    ),
    /* @__PURE__ */ t(
      K,
      {
        ...ce(a, { style: { ...a == null ? void 0 : a.style, ...$ } }),
        show: o,
        onRef: f.setFloating,
        onMouseEnter: ee,
        onMouseLeave: te,
        children: c ? Q : /* @__PURE__ */ t(A, { children: Z.map((e) => e.header ? /* @__PURE__ */ t(z, { children: e.header }, e.id) : e.itemText ? /* @__PURE__ */ t(H, { children: e.itemText }, e.id) : e.divider ? /* @__PURE__ */ t(q, {}, e.id) : e.as === "a" ? /* @__PURE__ */ t(O, { as: "a", href: e.href, active: e.active, disabled: e.disabled, children: e.item }, e.id) : /* @__PURE__ */ t(O, { as: "button", active: e.active, disabled: e.disabled, children: e.item }, e.id)) })
      }
    ),
    i && r && /* @__PURE__ */ t(g, { dropOldClass: !0, ...S, children: D })
  ] });
};
d.Toggle = g;
d.Item = O;
d.ItemText = H;
d.Menu = K;
d.Divider = q;
d.Header = z;
d.displayName = "BRL.Dropdown";
export {
  d as D
};
//# sourceMappingURL=dropdown.js.map
